#include "test.h"
#include "nobug.h"


TESTS_BEGIN

TEST(resources_announce_forget)
{
  RESOURCE_HANDLE(t1);
  RESOURCE_HANDLE_INIT (t1);
  RESOURCE_ANNOUNCE(NOBUG_ON, "type1", "test1", main, t1);
  RESOURCE_FORGET(NOBUG_ON, t1);
  RESOURCE_DUMPALL(NOBUG_ON);
}

/* Basic enter/leave tests */
TEST(resources_enter_exclusive_leave)
{
  RESOURCE_HANDLE(t1);
  RESOURCE_HANDLE_INIT (t1);
  RESOURCE_USER(e1);
  RESOURCE_USER_INIT (e1);
  RESOURCE_ANNOUNCE(NOBUG_ON, "type1", "test1", main, t1);

  RESOURCE_ENTER(NOBUG_ON, t1, "user1", NOBUG_RESOURCE_EXCLUSIVE, e1);
  RESOURCE_LEAVE(NOBUG_ON, e1);

  RESOURCE_DUMPALL(NOBUG_ON);
  RESOURCE_FORGET(NOBUG_ON, t1);
  RESOURCE_DUMPALL(NOBUG_ON);
}

TEST(resources_enter_waiting_leave)
{
  RESOURCE_HANDLE(t1);
  RESOURCE_HANDLE_INIT (t1);
  RESOURCE_USER(e1);
  RESOURCE_USER_INIT (e1);
  RESOURCE_ANNOUNCE(NOBUG_ON, "type1", "test1", main, t1);

  RESOURCE_ENTER(NOBUG_ON, t1, "user1", NOBUG_RESOURCE_WAITING, e1);
  RESOURCE_LEAVE(NOBUG_ON, e1);

  RESOURCE_DUMPALL(NOBUG_ON);
  RESOURCE_FORGET(NOBUG_ON, t1);
  RESOURCE_DUMPALL(NOBUG_ON);
}

TEST(resources_enter_recursive_leave)
{
  RESOURCE_HANDLE(t1);
  RESOURCE_HANDLE_INIT (t1);
  RESOURCE_USER(e1);
  RESOURCE_USER_INIT (e1);
  RESOURCE_ANNOUNCE(NOBUG_ON, "type1", "test1", main, t1);

  RESOURCE_ENTER(NOBUG_ON, t1, "user1", NOBUG_RESOURCE_RECURSIVE, e1);
  RESOURCE_LEAVE(NOBUG_ON, e1);

  RESOURCE_DUMPALL(NOBUG_ON);
  RESOURCE_FORGET(NOBUG_ON, t1);
  RESOURCE_DUMPALL(NOBUG_ON);
}

/* leaving too much tests */
TEST(resources_enter_exclusive_leave2)
{
  RESOURCE_HANDLE(t1);
  RESOURCE_HANDLE_INIT (t1);
  RESOURCE_USER(e1);
  RESOURCE_USER_INIT (e1);
  RESOURCE_ANNOUNCE(NOBUG_ON, "type1", "test1", main, t1);

  RESOURCE_ENTER(NOBUG_ON, t1, "user1", NOBUG_RESOURCE_EXCLUSIVE, e1);
  RESOURCE_LEAVE(NOBUG_ON, e1);
  RESOURCE_LEAVE(NOBUG_ON, e1);

  RESOURCE_DUMPALL(NOBUG_ON);
  RESOURCE_FORGET(NOBUG_ON, t1);
  RESOURCE_DUMPALL(NOBUG_ON);
}

TEST(resources_enter_waiting_leave2)
{
  RESOURCE_HANDLE(t1);
  RESOURCE_HANDLE_INIT (t1);
  RESOURCE_USER(e1);
  RESOURCE_USER_INIT (e1);
  RESOURCE_ANNOUNCE(NOBUG_ON, "type1", "test1", main, t1);

  RESOURCE_ENTER(NOBUG_ON, t1, "user1", NOBUG_RESOURCE_WAITING, e1);
  RESOURCE_LEAVE(NOBUG_ON, e1);
  RESOURCE_LEAVE(NOBUG_ON, e1);

  RESOURCE_DUMPALL(NOBUG_ON);
  RESOURCE_FORGET(NOBUG_ON, t1);
  RESOURCE_DUMPALL(NOBUG_ON);
}

TEST(resources_enter_recursive_leave2)
{
  RESOURCE_HANDLE(t1);
  RESOURCE_HANDLE_INIT (t1);
  RESOURCE_USER(e1);
  RESOURCE_USER_INIT (e1);
  RESOURCE_ANNOUNCE(NOBUG_ON, "type1", "test1", main, t1);

  RESOURCE_ENTER(NOBUG_ON, t1, "user1", NOBUG_RESOURCE_RECURSIVE, e1);
  RESOURCE_LEAVE(NOBUG_ON, e1);
  RESOURCE_LEAVE(NOBUG_ON, e1);

  RESOURCE_DUMPALL(NOBUG_ON);
  RESOURCE_FORGET(NOBUG_ON, t1);
  RESOURCE_DUMPALL(NOBUG_ON);
}



/* forgot to leave tests */
TEST(resources_enter_exclusive)
{
  RESOURCE_HANDLE(t1);
  RESOURCE_HANDLE_INIT (t1);
  RESOURCE_USER(e1);
  RESOURCE_USER_INIT (e1);
  RESOURCE_ANNOUNCE(NOBUG_ON, "type1", "test1", main, t1);

  RESOURCE_ENTER(NOBUG_ON, t1, "user1", NOBUG_RESOURCE_EXCLUSIVE, e1);

  RESOURCE_DUMPALL(NOBUG_ON);
  RESOURCE_FORGET(NOBUG_ON, t1);
  RESOURCE_DUMPALL(NOBUG_ON);
}

TEST(resources_enter_waiting)
{
  RESOURCE_HANDLE(t1);
  RESOURCE_HANDLE_INIT (t1);
  RESOURCE_USER(e1);
  RESOURCE_USER_INIT (e1);
  RESOURCE_ANNOUNCE(NOBUG_ON, "type1", "test1", main, t1);

  RESOURCE_ENTER(NOBUG_ON, t1, "user1", NOBUG_RESOURCE_WAITING, e1);

  RESOURCE_DUMPALL(NOBUG_ON);
  RESOURCE_FORGET(NOBUG_ON, t1);
  RESOURCE_DUMPALL(NOBUG_ON);
}

TEST(resources_enter_recursive)
{
  RESOURCE_HANDLE(t1);
  RESOURCE_HANDLE_INIT (t1);
  RESOURCE_USER(e1);
  RESOURCE_USER_INIT (e1);
  RESOURCE_ANNOUNCE(NOBUG_ON, "type1", "test1", main, t1);

  RESOURCE_ENTER(NOBUG_ON, t1, "user1", NOBUG_RESOURCE_RECURSIVE, e1);

  RESOURCE_DUMPALL(NOBUG_ON);
  RESOURCE_FORGET(NOBUG_ON, t1);
  RESOURCE_DUMPALL(NOBUG_ON);
}


/* State without enter tests */
TEST(resources_state_exclusive)
{
  RESOURCE_HANDLE(t1);
  RESOURCE_HANDLE_INIT (t1);
  RESOURCE_USER(e1);
  RESOURCE_USER_INIT (e1);
  RESOURCE_ANNOUNCE(NOBUG_ON, "type1", "test1", main, t1);

  RESOURCE_STATE(NOBUG_ON, NOBUG_RESOURCE_EXCLUSIVE, e1);

  RESOURCE_DUMPALL(NOBUG_ON);
  RESOURCE_FORGET(NOBUG_ON, t1);
  RESOURCE_DUMPALL(NOBUG_ON);
}

TEST(resources_state_waiting)
{
  RESOURCE_HANDLE(t1);
  RESOURCE_HANDLE_INIT (t1);
  RESOURCE_USER(e1);
  RESOURCE_USER_INIT (e1);
  RESOURCE_ANNOUNCE(NOBUG_ON, "type1", "test1", main, t1);

  RESOURCE_STATE(NOBUG_ON, NOBUG_RESOURCE_WAITING, e1);

  RESOURCE_DUMPALL(NOBUG_ON);
  RESOURCE_FORGET(NOBUG_ON, t1);
  RESOURCE_DUMPALL(NOBUG_ON);
}

TEST(resources_state_recursive)
{
  RESOURCE_HANDLE(t1);
  RESOURCE_HANDLE_INIT (t1);
  RESOURCE_USER(e1);
  RESOURCE_USER_INIT (e1);
  RESOURCE_ANNOUNCE(NOBUG_ON, "type1", "test1", main, t1);

  RESOURCE_STATE(NOBUG_ON, NOBUG_RESOURCE_RECURSIVE, e1);

  RESOURCE_DUMPALL(NOBUG_ON);
  RESOURCE_FORGET(NOBUG_ON, t1);
  RESOURCE_DUMPALL(NOBUG_ON);
}


/* waiting transistions valid tests */
TEST(resources_enter_waiting_state_exclusive)
{
  RESOURCE_HANDLE(t1);
  RESOURCE_HANDLE_INIT (t1);
  RESOURCE_USER(e1);
  RESOURCE_USER_INIT (e1);
  RESOURCE_ANNOUNCE(NOBUG_ON, "type1", "test1", main, t1);

  RESOURCE_ENTER(NOBUG_ON, t1, "user1", NOBUG_RESOURCE_WAITING, e1);
  RESOURCE_STATE(NOBUG_ON, NOBUG_RESOURCE_EXCLUSIVE, e1);
  RESOURCE_LEAVE(NOBUG_ON, e1);

  RESOURCE_DUMPALL(NOBUG_ON);
  RESOURCE_FORGET(NOBUG_ON, t1);
  RESOURCE_DUMPALL(NOBUG_ON);
}

TEST(resources_enter_waiting_state_recursive)
{
  RESOURCE_HANDLE(t1);
  RESOURCE_HANDLE_INIT (t1);
  RESOURCE_USER(e1);
  RESOURCE_USER_INIT (e1);
  RESOURCE_ANNOUNCE(NOBUG_ON, "type1", "test1", main, t1);

  RESOURCE_ENTER(NOBUG_ON, t1, "user1", NOBUG_RESOURCE_WAITING, e1);
  RESOURCE_STATE(NOBUG_ON, NOBUG_RESOURCE_RECURSIVE, e1);
  RESOURCE_LEAVE(NOBUG_ON, e1);

  RESOURCE_DUMPALL(NOBUG_ON);
  RESOURCE_FORGET(NOBUG_ON, t1);
  RESOURCE_DUMPALL(NOBUG_ON);
}


TEST(resources_enter_waiting_enter_waiting)
{
  RESOURCE_HANDLE(t1);
  RESOURCE_HANDLE_INIT (t1);
  RESOURCE_USER(e1);
  RESOURCE_USER_INIT (e1);
  RESOURCE_USER(e2);
  RESOURCE_USER_INIT (e2);
  RESOURCE_ANNOUNCE(NOBUG_ON, "type1", "test1", main, t1);

  RESOURCE_ENTER(NOBUG_ON, t1, "user1", NOBUG_RESOURCE_WAITING, e1);
  RESOURCE_ENTER(NOBUG_ON, t1, "user1", NOBUG_RESOURCE_WAITING, e2);
  RESOURCE_LEAVE(NOBUG_ON, e1);
  RESOURCE_LEAVE(NOBUG_ON, e2);

  RESOURCE_DUMPALL(NOBUG_ON);
  RESOURCE_FORGET(NOBUG_ON, t1);
  RESOURCE_DUMPALL(NOBUG_ON);
}

TEST(resources_enter_waiting_enter_recursive)
{
  RESOURCE_HANDLE(t1);
  RESOURCE_HANDLE_INIT (t1);
  RESOURCE_USER(e1);
  RESOURCE_USER_INIT (e1);
  RESOURCE_USER(e2);
  RESOURCE_USER_INIT (e2);
  RESOURCE_ANNOUNCE(NOBUG_ON, "type1", "test1", main, t1);

  RESOURCE_ENTER(NOBUG_ON, t1, "user1", NOBUG_RESOURCE_WAITING, e1);
  RESOURCE_ENTER(NOBUG_ON, t1, "user1", NOBUG_RESOURCE_RECURSIVE, e2);
  RESOURCE_LEAVE(NOBUG_ON, e1);
  RESOURCE_LEAVE(NOBUG_ON, e2);

  RESOURCE_FORGET(NOBUG_ON, t1);
  RESOURCE_DUMPALL(NOBUG_ON);
}

TEST(resources_enter_waiting_enter_exclusive)
{
  RESOURCE_HANDLE(t1);
  RESOURCE_HANDLE_INIT (t1);
  RESOURCE_USER(e1);
  RESOURCE_USER_INIT (e1);
  RESOURCE_USER(e2);
  RESOURCE_USER_INIT (e2);
  RESOURCE_ANNOUNCE(NOBUG_ON, "type1", "test1", main, t1);

  RESOURCE_ENTER(NOBUG_ON, t1, "user1", NOBUG_RESOURCE_WAITING, e1);
  RESOURCE_ENTER(NOBUG_ON, t1, "user1", NOBUG_RESOURCE_EXCLUSIVE, e2);
  RESOURCE_LEAVE(NOBUG_ON, e1);
  RESOURCE_LEAVE(NOBUG_ON, e2);

  RESOURCE_FORGET(NOBUG_ON, t1);
  RESOURCE_DUMPALL(NOBUG_ON);
}



/*exclusive tests*/
TEST(resources_enter_exclusive_state_waiting)
{
  RESOURCE_HANDLE(t1);
  RESOURCE_HANDLE_INIT (t1);
  RESOURCE_USER(e1);
  RESOURCE_USER_INIT (e1);
  RESOURCE_ANNOUNCE(NOBUG_ON, "type1", "test1", main, t1);

  RESOURCE_ENTER(NOBUG_ON, t1, "user1", NOBUG_RESOURCE_EXCLUSIVE, e1);
  RESOURCE_STATE(NOBUG_ON, NOBUG_RESOURCE_WAITING, e1);
  RESOURCE_LEAVE(NOBUG_ON, e1);

  RESOURCE_FORGET(NOBUG_ON, t1);
  RESOURCE_DUMPALL(NOBUG_ON);
}

TEST(resources_enter_exclusive_state_recursive)
{
  RESOURCE_HANDLE(t1);
  RESOURCE_HANDLE_INIT (t1);
  RESOURCE_USER(e1);
  RESOURCE_USER_INIT (e1);
  RESOURCE_ANNOUNCE(NOBUG_ON, "type1", "test1", main, t1);

  RESOURCE_ENTER(NOBUG_ON, t1, "user1", NOBUG_RESOURCE_EXCLUSIVE, e1);
  RESOURCE_STATE(NOBUG_ON, NOBUG_RESOURCE_RECURSIVE, e1);

  RESOURCE_DUMPALL(NOBUG_ON);
  RESOURCE_FORGET(NOBUG_ON, t1);
  RESOURCE_DUMPALL(NOBUG_ON);
}

TEST(resources_enter_exclusive_state_exclusive)
{
  RESOURCE_HANDLE(t1);
  RESOURCE_HANDLE_INIT (t1);
  RESOURCE_USER(e1);
  RESOURCE_USER_INIT (e1);
  RESOURCE_ANNOUNCE(NOBUG_ON, "type1", "test1", main, t1);

  RESOURCE_ENTER(NOBUG_ON, t1, "user1", NOBUG_RESOURCE_EXCLUSIVE, e1);
  RESOURCE_STATE(NOBUG_ON, NOBUG_RESOURCE_EXCLUSIVE, e1);

  RESOURCE_DUMPALL(NOBUG_ON);
  RESOURCE_FORGET(NOBUG_ON, t1);
  RESOURCE_DUMPALL(NOBUG_ON);
}

TEST(resources_enter_exclusive_enter_waiting)
{
  RESOURCE_HANDLE(t1);
  RESOURCE_HANDLE_INIT (t1);
  RESOURCE_USER(e1);
  RESOURCE_USER_INIT (e1);
  RESOURCE_USER(e2);
  RESOURCE_USER_INIT (e2);
  RESOURCE_ANNOUNCE(NOBUG_ON, "type1", "test1", main, t1);

  RESOURCE_ENTER(NOBUG_ON, t1, "user1", NOBUG_RESOURCE_EXCLUSIVE, e1);
  RESOURCE_ENTER(NOBUG_ON, t1, "user1", NOBUG_RESOURCE_WAITING, e2);
  RESOURCE_LEAVE(NOBUG_ON, e1);
  RESOURCE_LEAVE(NOBUG_ON, e2);

  RESOURCE_FORGET(NOBUG_ON, t1);
}

TEST(resources_enter_exclusive_enter_recursive)
{
  RESOURCE_HANDLE(t1);
  RESOURCE_HANDLE_INIT (t1);
  RESOURCE_USER(e1);
  RESOURCE_USER_INIT (e1);
  RESOURCE_USER(e2);
  RESOURCE_USER_INIT (e2);
  RESOURCE_ANNOUNCE(NOBUG_ON, "type1", "test1", main, t1);

  RESOURCE_ENTER(NOBUG_ON, t1, "user1", NOBUG_RESOURCE_EXCLUSIVE, e1);
  RESOURCE_ENTER(NOBUG_ON, t1, "user1", NOBUG_RESOURCE_RECURSIVE, e2);

  RESOURCE_DUMPALL(NOBUG_ON);
  RESOURCE_FORGET(NOBUG_ON, t1);
  RESOURCE_DUMPALL(NOBUG_ON);
}

TEST(resources_enter_exclusive_enter_exclusive)
{
  RESOURCE_HANDLE(t1);
  RESOURCE_HANDLE_INIT (t1);
  RESOURCE_USER(e1);
  RESOURCE_USER_INIT (e1);
  RESOURCE_USER(e2);
  RESOURCE_USER_INIT (e2);
  RESOURCE_ANNOUNCE(NOBUG_ON, "type1", "test1", main, t1);

  RESOURCE_ENTER(NOBUG_ON, t1, "user1", NOBUG_RESOURCE_EXCLUSIVE, e1);
  RESOURCE_ENTER(NOBUG_ON, t1, "user1", NOBUG_RESOURCE_EXCLUSIVE, e2);

  RESOURCE_DUMPALL(NOBUG_ON);
  RESOURCE_FORGET(NOBUG_ON, t1);
  RESOURCE_DUMPALL(NOBUG_ON);
}

/*recursive tests*/
TEST(resources_enter_recursive_state_waiting)
{
  RESOURCE_HANDLE(t1);
  RESOURCE_HANDLE_INIT (t1);
  RESOURCE_USER(e1);
  RESOURCE_USER_INIT (e1);
  RESOURCE_ANNOUNCE(NOBUG_ON, "type1", "test1", main, t1);

  RESOURCE_ENTER(NOBUG_ON, t1, "user1", NOBUG_RESOURCE_RECURSIVE, e1);
  RESOURCE_STATE(NOBUG_ON, NOBUG_RESOURCE_WAITING, e1);
  RESOURCE_LEAVE(NOBUG_ON, e1);

  RESOURCE_FORGET(NOBUG_ON, t1);
}

TEST(resources_enter_recursive_state_recursive)
{
  RESOURCE_HANDLE(t1);
  RESOURCE_HANDLE_INIT (t1);
  RESOURCE_USER(e1);
  RESOURCE_USER_INIT (e1);
  RESOURCE_ANNOUNCE(NOBUG_ON, "type1", "test1", main, t1);

  RESOURCE_ENTER(NOBUG_ON, t1, "user1", NOBUG_RESOURCE_RECURSIVE, e1);
  RESOURCE_STATE(NOBUG_ON, NOBUG_RESOURCE_RECURSIVE, e1);

  RESOURCE_DUMPALL(NOBUG_ON);
  RESOURCE_FORGET(NOBUG_ON, t1);
  RESOURCE_DUMPALL(NOBUG_ON);
}

TEST(resources_enter_recursive_state_exclusive)
{
  RESOURCE_HANDLE(t1);
  RESOURCE_HANDLE_INIT (t1);
  RESOURCE_USER(e1);
  RESOURCE_USER_INIT (e1);
  RESOURCE_ANNOUNCE(NOBUG_ON, "type1", "test1", main, t1);

  RESOURCE_ENTER(NOBUG_ON, t1, "user1", NOBUG_RESOURCE_RECURSIVE, e1);
  RESOURCE_STATE(NOBUG_ON, NOBUG_RESOURCE_EXCLUSIVE, e1);

  RESOURCE_DUMPALL(NOBUG_ON);
  RESOURCE_FORGET(NOBUG_ON, t1);
  RESOURCE_DUMPALL(NOBUG_ON);
}

TEST(resources_enter_recursive_enter_waiting)
{
  RESOURCE_HANDLE(t1);
  RESOURCE_HANDLE_INIT (t1);
  RESOURCE_USER(e1);
  RESOURCE_USER_INIT (e1);
  RESOURCE_USER(e2);
  RESOURCE_USER_INIT (e2);
  RESOURCE_ANNOUNCE(NOBUG_ON, "type1", "test1", main, t1);

  RESOURCE_ENTER(NOBUG_ON, t1, "user1", NOBUG_RESOURCE_RECURSIVE, e1);
  RESOURCE_ENTER(NOBUG_ON, t1, "user1", NOBUG_RESOURCE_WAITING, e2);
  RESOURCE_LEAVE(NOBUG_ON, e1);
  RESOURCE_LEAVE(NOBUG_ON, e2);

  RESOURCE_DUMPALL(NOBUG_ON);
  RESOURCE_FORGET(NOBUG_ON, t1);
  RESOURCE_DUMPALL(NOBUG_ON);
}


TEST(resources_enter_recursive_enter_exclusive)
{
  RESOURCE_HANDLE(t1);
  RESOURCE_HANDLE_INIT (t1);
  RESOURCE_USER(e1);
  RESOURCE_USER_INIT (e1);
  RESOURCE_USER(e2);
  RESOURCE_USER_INIT (e2);
  RESOURCE_ANNOUNCE(NOBUG_ON, "type1", "test1", main, t1);

  RESOURCE_ENTER(NOBUG_ON, t1, "user1", NOBUG_RESOURCE_RECURSIVE, e1);
  RESOURCE_ENTER(NOBUG_ON, t1, "user1", NOBUG_RESOURCE_EXCLUSIVE, e2);

  RESOURCE_DUMPALL(NOBUG_ON);
  RESOURCE_FORGET(NOBUG_ON, t1);
  RESOURCE_DUMPALL(NOBUG_ON);
}

TESTS_END
